#pragma once
#include <iostream>

namespace spin
{
    struct Screw
    {
        enum Type
        {
            MACHINE,
            SELF_TAPPING
        };

        Screw(int id, std::string name, Type type, double length_mm)
            : id_(id), name_(name), type_(type), length_mm_(length_mm)
        {
        }

        inline friend std::ostream &operator<<(std::ostream &out, const Screw &screw)
        {
            out << "id: " << screw.id_ << std::endl;
            out << "name: " << screw.name_ << std::endl;
            out << "type: " << screw.type_ << std::endl;
            out << "length_mm: " << screw.length_mm_ << std::endl;
            return out;
        }

        std::string toString() const
        {
            std::ostringstream oss;
            oss << *this;
            return oss.str();
        }

        int id_;
        std::string name_;
        Type type_;
        double length_mm_;
    };
}